<template>
  <div>
    <div class="flex flex-row items-center justify-start lg:justify-center">
      <colors-indicator :value="workspace.color" @input="workspace.$setAndSaveAttributes({ color: $event })" />
      <inputt
        placeholder="Choose a name"
        type="text"
        ref="nameinput"
        :value="workspace.name"
        class="flex-1"
        @input="workspace.name = $event"
        @enter="save()"
      ></inputt>
    </div>
    <div class="mt-8">
      <div class="font-bold">Icon</div>
      <div class="flex flex-row items-center justify-start mt-2 flex-wrap">
        <i
          v-for="icon of icons"
          :key="icon"
          @click="workspace.$setAndSaveAttributes({ icon })"
          :class="
            `hero solid ${icon} p-2 rounded-full clickable ${
              workspace.icon == icon ? `bg-${workspace.color}-500 text-white` : ''
            }`
          "
        ></i>
      </div>
    </div>
    <div class="sticky bottom-0 left-0 lg:static p-4 lg:p-0 lg:pt-8 flex flex-row items-center justify-between">
      <div
        @click="modals.show('confirmator')"
        v-if="workspace.$isPersistent"
        class="rounded-full bg-red-200 text-red-800 p-2 mr-4 w-10 h-10 flex flex-row items-center justify-center text-base uppercase tracking-wide cursor-pointer select-none"
      >
        <i class="hero trash outline"></i>
      </div>
      <div v-else></div>
      <div
        @click="save()"
        v-if="!workspace.$isPersistent"
        class="button bg-green-600 hover:bg-green-700 active:bg-green-900"
      >
        <i class="hero check outline text-lg mr-2"></i>
        Save
      </div>
    </div>
    <modal
      :is="modals.get('confirmator')"
      @confirm="workspace.delete().then(() => $emit('deleted'))"
      title="Delete Workspace"
      color="red"
      action="Delete"
    >
      Are you sure you want to remove this Workspace? This can
      <span class="font-bold">not</span> be undone!
    </modal>
  </div>
</template>

<script lang="ts">
import Workspace from "@/models/Workspace";
import WorkspacesIcon from "@/components/Workspaces/Icon.vue";
import ColorsIndicator from "@/components/Colors/Indicator.vue";
import Confirmator from "@/components/Confirmator.vue";
import Inputt from "@/components/Inputt.vue";
import { ref, onMounted } from "vue";
import { useModals } from "@/use/modal";
import { Autosaver } from "@/use/autosaver";
import { iconNames } from "@/assets/heroicons";

export default {
  components: { WorkspacesIcon, ColorsIndicator, Inputt },
  emits: ["saved", "deleted"],
  props: {
    workspace: {
      type: Workspace,
      required: true
    },
    focus: {
      type: Boolean,
      default: false
    }
  },
  setup(props, context) {
    const modals = useModals({ Confirmator });
    const nameinput = ref<HTMLElement | null>(null);

    new Autosaver(() => props.workspace, { timeout: 1000 }).useDefaultLifecycle();

    onMounted(() => {
      if (props.focus) {
        nameinput.value!.focus();
      }
    });

    return {
      nameinput,
      modals,
      icons: iconNames,
      save: async () => {
        await props.workspace.save();
        context.emit("saved");
      }
    };
  }
};
</script>
